__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a4"
__cvsversion__ = "$Revision: 1.11 $"
__date__       = "$Date: 2004/06/28 22:49:36 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA. This library (rBloom.py) is derived from the \
pyDC bloom.py library and is released under the terms of the GPL \
license."

# $Id: rBloom.py,v 1.11 2004/06/28 22:49:36 asc Exp $

# see also :
# http://cvs.sourceforge.net/viewcvs.py/pydc/pydc/pyDClib/bloom.py?view=markup

from array import array
from struct import unpack
from base64 import encodestring, decodestring

import md5

class rBloom:
	LOAD_FACTOR = 8
	ITEMS       = 1024

        # we might eventually let users define
        # a ceiling but for now it is hard-coded
        
	def __init__(self,items=0):
		self.bits   = self.ITEMS * self.LOAD_FACTOR
		self.bitmap = array('B', '\0' * (self.bits >> 3))
	
	def add(self, pattern):

		m = md5.new()
		m.update(pattern)
		
		idxs = unpack('4I', m.digest())
		for i in idxs:
			i %= self.bits
			offset, mask = i >> 3, 1 << (i % 8)
			self.bitmap[offset] |= mask
	
	def match(self, pattern):
		m = md5.new()
		m.update(pattern)
		
		idxs = unpack('4I', m.digest())
		for i in idxs:
			i %= self.bits
			offset, mask = i >> 3, 1 << (i % 8)
			if self.bitmap[offset] & mask != mask:
				return False
		
		return True

	def fromstring (self, str):
            a = array('B')
            a.fromstring(str)
            self.bitmap = a
            
	def tostring (self):
	    return self.bitmap.tostring()

        def fromstring_encoded (self,str):
            return self.fromstring(decodestring(str))

        def tostring_encoded (self) :
            return encodestring(self.tostring())
