__author__     = "Aaron Straup Cope"
__url__        = "http://aaronland.info/python/w5"
__version__    = "1.0a4"
__cvsversion__ = "$Revision: 1.27 $"
__date__       = "$Date: 2004/06/28 22:49:37 $"
__copyright__  = "%s\n%s\n%s" % \
                 ("This application is licensed under the",
                  "Creative Commons Attribution-NonCommercial License",
                  "http://creativecommons.org/licenses/by-nc/1.0/")

__license__    = "This application is licensed under the Creative \
Commons Attribution-NonCommercial License. To view a copy of this \
license, visit http://creativecommons.org/licenses/by-nc/1.0/ or send \
a letter to Creative Commons, 559 Nathan Abbott Way, Stanford, \
California 94305, USA."

# $Id: rPrefs.py,v 1.27 2004/06/28 22:49:37 asc Exp $

from wxPython.wx import *
from rEdit       import rEdit

ID_PREFSBOX     = wxNewId()
ID_SERVICELIST  = wxNewId()
ID_ADDBUTTON    = wxNewId()
ID_EDITBUTTON   = wxNewId()
ID_REMOVEBUTTON = wxNewId()
ID_IMPORTBUTTON = wxNewId()
ID_CLOSEBUTTON  = wxNewId()

class rPrefs (wxFrame) :

    def __init__ (self,parent,style,cfg):
        wxFrame.__init__(self,parent,style,"Services")

        self.__cfg__      = cfg    
        self.__selected__ = None

        self.__controls__ = {"current":0};
        self.__ctrlkeys__ = [];

	self.__redit__ = 0

        # can I pass a 'sizer' rather than
        # hard-code the dimensions? - no

	# compute the height/width based on
	# the length of the text a la MP
	# status bar hack - what happens when
	# new stuff is added?

	# not an ideal solution...

        self.__addcontrol(wxListCtrl(self, ID_SERVICELIST,
                                     (0,0), (150,75),
                                     wxLC_SINGLE_SEL,
                                     ))

        self.__addcontrol(wxButton(self,ID_ADDBUTTON,
                                   "&Add"))

        self.__addcontrol(wxButton(self,ID_EDITBUTTON,
                                   "&Edit"))
        
        self.__addcontrol(wxButton(self,ID_REMOVEBUTTON,
                                   "&Remove"))
        
        self.__addcontrol(wxButton(self,ID_CLOSEBUTTON,
                                   "&Close"))

        #
        
        self.LoadServices()
        
        self.__controls__[ID_EDITBUTTON].Enable(false)
        self.__controls__[ID_REMOVEBUTTON].Enable(false)
        
        #

        spacer = wxSize(5,5)
        
	sz_services = wxBoxSizer(wxHORIZONTAL)
        sz_buttons  = wxBoxSizer(wxVERTICAL)
        
        sz_buttons.Add(self.__controls__[ID_ADDBUTTON])
        sz_buttons.Add(self.__controls__[ID_EDITBUTTON])
        sz_buttons.Add(self.__controls__[ID_REMOVEBUTTON])
        
        sz_close = wxBoxSizer(wxHORIZONTAL)
        sz_close.Add(self.__controls__[ID_CLOSEBUTTON])
        
        sz_services.Add(self.__controls__[ID_SERVICELIST],1,wxEXPAND)
        sz_services.Add(spacer)
        sz_services.Add(sz_buttons)
 
        sz_body = wxBoxSizer(wxVERTICAL)

        sz_body.Add(sz_services)
        sz_body.Add(spacer)        
        sz_body.Add(wxStaticLine(self,-1),0,wxEXPAND)
        sz_body.Add(spacer)
        sz_body.Add(spacer)
        sz_body.Add(sz_close,0,wxALIGN_RIGHT)

	sz_padx = wxBoxSizer(wxHORIZONTAL)
	sz_padx.Add(spacer)
	sz_padx.Add(sz_body)
	sz_padx.Add(spacer)

	sz_main = wxBoxSizer(wxVERTICAL)
	sz_main.Add(spacer)
	sz_main.Add(sz_padx)
	sz_main.Add(spacer)
	
	self.SetSizer(sz_main)
        self.SetAutoLayout(1)

        self.CreateStatusBar()
        sz_main.Fit(self)

        #
        
        EVT_BUTTON(self, ID_ADDBUTTON,    self.Add)
        EVT_BUTTON(self, ID_EDITBUTTON,   self.Edit)
        EVT_BUTTON(self, ID_REMOVEBUTTON, self.Remove)
        EVT_BUTTON(self, ID_CLOSEBUTTON,  self.Close)

	EVT_KEY_DOWN(self,self.KeyDown)

	# I'm not sure why this is necessary - to make
        # matters worse, keyboard events appear to be
        # locked by the control key in ListCtrl - that
        # no other key events are captured  until the
        # user lets go of the control key. I don't know
        # whether tis is a short-coming in wxPython or
        # me
        
	EVT_LIST_KEY_DOWN(self,ID_SERVICELIST, self.ListKeyDown)

        EVT_LIST_ITEM_SELECTED(self, ID_SERVICELIST, self.EvtListCtrl)
        EVT_LIST_ITEM_ACTIVATED(self, ID_SERVICELIST, self.EvtListCtrlDClick)

	# this is just to save typing...

	list = self.__controls__[ID_SERVICELIST]


	if list.GetItemCount() > 0 :

           list.SetFocus()            
	   list.SetItemState(0,
		             wxLIST_STATE_SELECTED,
			     wxLIST_STATE_SELECTED)

        else :

            cur = self.__ctrlkeys__.index(ID_ADDBUTTON)
            self.__controls__["current"] = cur
            
            add = self.__controls__[ID_ADDBUTTON]
            add.SetFocus()


    #
    
    def ListKeyDown(self,event) :

        keycode = event.GetKeyCode()
	keyname = ""

        if keycode <= 256:
           keyname = chr(keycode).upper()

        if keyname == "E":
            self.Edit(event)
        elif keyname == "R":
            self.Remove(event)
        else:
            pass
    
    def KeyDown(self,event):

        keycode = event.GetKeyCode()

        if keycode == WXK_TAB :

            cur   = self.__controls__["current"]
            count = len(self.__ctrlkeys__) - 1

            # note that we are accounting
            # for controls that may be disabled
            
            ctrl = None

            while ctrl == None:
                if event.ShiftDown() :
                    if cur == 0 :
                        cur = count
                    else :
                        cur = cur - 1
                else :
                    if cur >= count :
                        cur = 0
                    else :
                        cur = cur + 1
            
                id  = self.__ctrlkeys__[ cur ]

                # don't bother stopping on the
                # list control if there are no
                # services to list

                if id == ID_SERVICELIST:
                    if self.__controls__[ id].GetItemCount() <= 0:
                        continue
                
                #
                
                if self.__controls__[ id].IsEnabled() :
                    self.__controls__["current"] = cur     
                    ctrl = self.__controls__[ id ]

            ctrl.SetFocus()

        elif keycode == WXK_RETURN :

            cur = self.__controls__["current"]
            id  = self.__ctrlkeys__[ cur ]
            
            if id == ID_ADDBUTTON:
                self.Add(event)
            elif id == ID_EDITBUTTON:
                self.Edit(event)
            elif id == ID_REMOVEBUTTON:
                self.Remove(event)
            elif id == ID_CLOSEBUTTON:
                self.Close(event)                
            else:
                pass
            
        elif event.ControlDown():

            if keycode <= 256:
                keyname = chr(keycode)
        
            if keyname == "A":
                self.Add(event)
            elif keyname == "C":
                self.Close(event)
            elif keyname == "E":
                self.Edit(event)
            elif keyname == "R":
                self.Remove(event)
            else:
                pass
            
	else:
            pass


    #
    
    def EvtListCtrl (self,event):
        self.__controls__[ID_EDITBUTTON].Enable(true)
        self.__controls__[ID_REMOVEBUTTON].Enable(true)
        self.__selected__ = event.m_itemIndex

    #
    
    def EvtListCtrlDClick (self,event):
        self.__selected__ = event.m_itemIndex
        self.Edit(event)

    #
    
    def LoadServices (self) :

        self.__cfg__.Load()

	self.__controls__[ID_SERVICELIST].ClearAll()

        self.__titles__    = []
        self.__endpoints__ = []

        i = 0

        # sort me!
        
        for s in self.__cfg__.ListServices():

            endpoint = self.__cfg__.DescribeService(s).Endpoint()
            title    = self.__cfg__.DescribeService(s).Title()

            self.__titles__.append(title)            
            self.__endpoints__.append(endpoint)

            self.__controls__[ID_SERVICELIST].InsertStringItem(i,title)
            i = i + 1

    #

    def Add(self,event):

	self.DisableControls()

	(x,y) = self.GetPosition()
        
        edit = rEdit(self,-1,self.__cfg__)
	edit.SetPosition((x - 25,y + 50))
        edit.Show()

    #
    
    def Edit(self,event):

        if self.__selected__ == None :
            return

	self.DisableControls()

        endpoint = self.__endpoints__[ self.__selected__ ]
        
        edit = rEdit(self,-1,self.__cfg__,endpoint)
        edit.Show()

    #
    
    def Remove(self,event):

        if self.__selected__ == None :
            return

        endpoint = self.__endpoints__[ self.__selected__ ]
        self.__cfg__.RemoveService(endpoint)

        self.LoadServices()

        #

        if len(self.__endpoints__) == 0:
            return

        #
        
	if self.__selected__ == 0 :
	   self.__selected__ = len(self.__endpoints__) - 1
	else :
	   self.__selected__ = self.__selected__ - 1

        self.SelectCurrentEndpoint()

    #
    
    def Close(self,event):
        self.Destroy()

    # this is here mostly so that
    # self.__selected__ can be gotten
    # at by rEdit.py when adding new
    # services
    
    def Selected (self,which=None) :

        # god help me - is this
        # the only way?!

        test = str(type(which))
        
        if test == "<type 'int'>" :
	   self.__selected__ = which
        elif test == "<type 'str'>" :
            self.__selected__ = self.__endpoints__.index(which)
        else:
            pass
        
	return self.__selected__

    #

    def DisableControls (self) :
        self.__controls__[ID_ADDBUTTON].Enable(false)
        self.__controls__[ID_EDITBUTTON].Enable(false)
        self.__controls__[ID_REMOVEBUTTON].Enable(false)

    #

    def EnableControls (self) :
        self.__controls__[ID_ADDBUTTON].Enable(true)
        self.__controls__[ID_EDITBUTTON].Enable(true)
        self.__controls__[ID_REMOVEBUTTON].Enable(true)

	#

	cur = self.__ctrlkeys__[self.__controls__["current"]]
	self.__controls__[cur].SetFocus()

	#

        self.SelectCurrentEndpoint()

    def SelectCurrentEndpoint (self) :

	list = self.__controls__[ID_SERVICELIST]

        if list.GetItemCount <= 0 :
            return

        # print "sel %s (%s)" % (self.__selected__,self.__titles__)
        
        sel = self.__titles__[self.__selected__]
        
        list.SetItemState(list.FindItem(-1,sel),
                          wxLIST_STATE_SELECTED,
                          wxLIST_STATE_SELECTED)
    
    #
    
    def __addcontrol (self,ctrl) :
        id = ctrl.GetId()
        
        self.__controls__[ id ] = ctrl
        self.__ctrlkeys__.append(id)
